diff --git a/nuxeo-drive-client/nxdrive/client/rest_api_client.py b/nuxeo-drive-client/nxdrive/client/rest_api_client.py
index ae5482c..240aeee 100644
--- a/nuxeo-drive-client/nxdrive/client/rest_api_client.py
+++ b/nuxeo-drive-client/nxdrive/client/rest_api_client.py
@@ -33,10 +33,10 @@ class RestAPIClient(object):
             cookiejar=cookie_jar)
         self.opener = urllib2.build_opener(cookie_processor)
 
-    def execute(self, doc_path, adapter=None, timeout=-1):
+    def execute(self, relative_url, adapter=None, timeout=-1):
         """Execute a REST API call"""
 
-        url = self.rest_api_url + 'path' + doc_path
+        url = self.rest_api_url + relative_url
         if adapter is not None:
             url += '/@' + adapter
 
@@ -119,3 +119,7 @@ class RestAPIClient(object):
                 # Error message should always be a JSON message,
                 # but sometimes it's not
                 log.debug(detail)
+                
+    def get_user_full_name(self, userid, adapter=None, timeout=-1):
+        """Execute a REST API call to get User Information"""
+        return self.execute(relative_url='user/'+ userid)
diff --git a/nuxeo-drive-client/nxdrive/engine/engine.py b/nuxeo-drive-client/nxdrive/engine/engine.py
index 41a1b1b..078deb2 100644
--- a/nuxeo-drive-client/nxdrive/engine/engine.py
+++ b/nuxeo-drive-client/nxdrive/engine/engine.py
@@ -187,6 +187,8 @@ class Engine(QObject):
         self._scanPair.connect(self._remote_watcher.scan_pair)
         # Set the root icon
         self._set_root_icon()
+        # Set user full name
+        self._userCache = dict()
 
     @pyqtSlot(object)
     def _check_sync_start(self, row_id):
@@ -881,3 +883,10 @@ class Engine(QObject):
     def dispose_db(self):
         if self._dao is not None:
             self._dao.dispose()
+            
+    def get_rest_api_client(self):
+        from nxdrive.client.rest_api_client import RestAPIClient
+        rest_client = RestAPIClient(self.get_server_url(), self.get_remote_user(),
+                                        self._manager.get_device_id(), self._manager.client_version, None,
+                                        self.get_remote_token(), timeout=self.timeout, cookie_jar=self.cookie_jar)
+        return rest_client
diff --git a/nuxeo-drive-client/nxdrive/wui/conflicts.py b/nuxeo-drive-client/nxdrive/wui/conflicts.py
index 699970c..18f387a 100644
--- a/nuxeo-drive-client/nxdrive/wui/conflicts.py
+++ b/nuxeo-drive-client/nxdrive/wui/conflicts.py
@@ -77,12 +77,31 @@ class WebConflictsApi(WebDriveApi):
         if state is None:
             return None
         result = super(WebConflictsApi, self)._export_state(state)
-        result["last_contributor"] = state.last_remote_modifier
+        result["last_contributor"] = self.get_user_full_name(state.last_remote_modifier)
         date_time = self.get_date_from_sqlite(state.last_remote_updated)
         result["last_remote_update"] = "" if date_time == 0 else Translator.format_datetime(date_time)
         date_time = self.get_date_from_sqlite(state.last_local_updated)
         result["last_local_update"] = "" if date_time == 0 else Translator.format_datetime(date_time)
         return result
+    
+    def get_user_full_name(self, userid):
+        """
+            Get the last contributor full name
+        """
+        fullname = userid
+        try:
+            if userid in self._engine._userCache:
+                fullname = self._engine._userCache[userid]
+            else:
+                rest_client = self._engine.get_rest_api_client()
+                response = rest_client.get_user_full_name(userid)
+                if response and 'properties' in response:
+                    fullname = " ".join([response['properties']['firstName'], 
+                                         response['properties']['lastName']]).strip()
+                    self._engine._userCache[userid] = fullname
+        except Exception as e:
+            log.exception(e)
+        return fullname
 
 
 class WebConflictsDialog(WebDialog):
diff --git a/nuxeo-drive-client/nxdrive/wui/dialog.py b/nuxeo-drive-client/nxdrive/wui/dialog.py
index b4bd8e2..4060e89 100644
--- a/nuxeo-drive-client/nxdrive/wui/dialog.py
+++ b/nuxeo-drive-client/nxdrive/wui/dialog.py
@@ -675,8 +675,8 @@ class WebDialog(QtGui.QDialog):
             self._api = api
         self._attachJsApi()
         self._frame.javaScriptWindowObjectCleared.connect(self._attachJsApi)
-        self.resize(400, 400)
-        self._view.resize(400, 400)
+        self.resize(550, 600)
+        self._view.resize(550, 600)
         self.setLayout(QtGui.QVBoxLayout())
         self.layout().addWidget(self._view)
         self.layout().setContentsMargins(0, 0, 0, 0)